#define _BSD_SOURCE	/* daemon() */
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "pidof.h"

void usage_bail(void)
{
	printf("Usage: supervise [-f] cmd [cmd_args]\n");
	exit(1);
}

int exec(char **argv)
{
	int pid;

	if ((pid = fork()) == -1) {
		perror("fork()");
		return 1;
	}

	if (pid) { /* parent */
		waitpid(pid, NULL, 0);
	} else { /* child */
		if (execvp(argv[0], argv)) {
			perror("execv()");
			exit(errno);
		}
	}
	return 0;
}

int main(int argc, char **argv)
{
	if (argc < 2)
		usage_bail();
	argv++;

	if (strcmp(*argv, "-f")) {
		if (daemon(0, 0))
			perror("daemon()");
	} else {
		if (argc < 3)
			usage_bail();
		argv++;
	}

	while (1) {
		if (pidof(*argv)) {
			sleep(10);
			continue;
		}
		exec(argv);
	}

	/* not reached */
	return 0;
}
